<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Lexer.hh.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Lexer.hh</title>
<link href="../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../Scopes/global.html" >Global Namespace</a></span>
<span class="normal"><a href="../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Lexer.hh</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="comment">//</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="comment">// Copyright (C) 2004 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="comment">// All rights reserved.</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="comment">// Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="comment">// see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="comment">//</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line">#ifndef Synopsis_Lexer_hh_</span>
<a id="line8"></a><span class="lineno">  8</span><span class="line">#define Synopsis_Lexer_hh_</span>
<a id="line9"></a><span class="lineno">  9</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line">#include &lt;Synopsis/Token.hh&gt;</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line">#include &lt;vector&gt;</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line">#include &lt;map&gt;</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line">#include &lt;deque&gt;</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line">#include &lt;stdexcept&gt;</span>
<a id="line15"></a><span class="lineno"> 15</span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line"><span class="keyword">namespace</span> <a href="../../Scopes/Synopsis.html" title="namespace Synopsis">Synopsis</a></span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line">{</span>
<a id="line18"></a><span class="lineno"> 18</span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line">class Buffer;</span>
<a id="line20"></a><span class="lineno"> 20</span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line"><span class="comment">//. a Lexer reads tokens from a stream.</span></span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line"><span class="keyword">class</span> <a href="../../Scopes/Synopsis/Lexer.html" title="class Synopsis::Lexer">Lexer</a></span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line">{</span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line">  <span class="comment">//. Define sets of token that are to be recognized as special</span></span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line"><span class="comment">  //. keywords (as opposed to identifiers). They can be or'ed.</span></span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line"><span class="comment">  //. If CXX is not specified, the Lexer will operate in 'C mode'.</span></span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line">  <span class="keyword">enum</span> <a href="../../Scopes/Synopsis/Lexer.html#TokenSet" title="enum Synopsis::Lexer::TokenSet">TokenSet</a> { <a href="../../Scopes/Synopsis/Lexer.html#C" title="enumerator Synopsis::Lexer::C">C</a>=0x0, <a href="../../Scopes/Synopsis/Lexer.html#CXX" title="enumerator Synopsis::Lexer::CXX">CXX</a>=0x01, <a href="../../Scopes/Synopsis/Lexer.html#GCC" title="enumerator Synopsis::Lexer::GCC">GCC</a>=0x02, <a href="../../Scopes/Synopsis/Lexer.html#MSVC" title="enumerator Synopsis::Lexer::MSVC">MSVC</a>=0x04};</span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line">  <span class="keyword">typedef</span> std::<a href="" title="class std::vector">vector</a>&lt;<a href="../../Scopes/Synopsis/Token.html" title="struct Synopsis::Token">Token</a>&gt; <a href="../../Scopes/Synopsis/Lexer.html#Comments" title="typedef Synopsis::Lexer::Comments">Comments</a>;</span>
<a id="line30"></a><span class="lineno"> 30</span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line">  <span class="keyword">struct</span> <a href="../../Scopes/Synopsis/Lexer/InvalidChar.html" title="struct Synopsis::Lexer::InvalidChar">InvalidChar</a> : <a href="" title="class std::runtime_error">std::runtime_error</a></span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line">  {</span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line">    <a href="" title="member function Synopsis::Lexer::InvalidChar::InvalidChar(const std::string&amp;)">InvalidChar</a>(<span class="keyword">const</span> <a href="" title="typedef std::string">std::string</a> &amp;msg) : std::runtime_error(msg) {}</span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line">  };</span>
<a id="line35"></a><span class="lineno"> 35</span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line">  <span class="comment">//. Construct a Lexer on the given Buffer using the given</span></span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line"><span class="comment">  //. token set. The default token set is CXX with GCC extensions.</span></span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">  <a href="../../Scopes/Synopsis/Lexer.html#Lexer_lBuffer_S_cint_r" title="member function Synopsis::Lexer::Lexer(Buffer*,int)">Lexer</a>(<a href="../../Scopes/Synopsis/Buffer.html" title="class Synopsis::Buffer">Buffer</a> *, <span class="keyword">int</span> tokenset = CXX|GCC);</span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line">  <a href="../../Scopes/Synopsis/Token.html#Type" title="typedef Synopsis::Token::Type">Token::Type</a> <a href="../../Scopes/Synopsis/Lexer.html#get_token_lToken_A_r" title="member function Synopsis::Lexer::get_token(Token&amp;)">get_token</a>(<a href="../../Scopes/Synopsis/Token.html" title="struct Synopsis::Token">Token</a> &amp;);</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">  <a href="../../Scopes/Synopsis/Token.html#Type" title="typedef Synopsis::Token::Type">Token::Type</a> <a href="../../Scopes/Synopsis/Lexer.html#look_ahead_lsize_t_r" title="member function Synopsis::Lexer::look_ahead(size_t)">look_ahead</a>(<a href="" title="typedef size_t">size_t</a>);</span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">  <a href="../../Scopes/Synopsis/Token.html#Type" title="typedef Synopsis::Token::Type">Token::Type</a> <a href="../../Scopes/Synopsis/Lexer.html#look_ahead_lsize_t_cToken_A_r" title="member function Synopsis::Lexer::look_ahead(size_t,Token&amp;)">look_ahead</a>(<a href="" title="typedef size_t">size_t</a>, <a href="../../Scopes/Synopsis/Token.html" title="struct Synopsis::Token">Token</a> &amp;);</span>
<a id="line42"></a><span class="lineno"> 42</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">  <span class="keyword">const</span> <span class="keyword">char</span> *<a href="../../Scopes/Synopsis/Lexer.html#save_l_r" title="member function Synopsis::Lexer::save()">save</a>();</span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line">  <span class="keyword">void</span> <a href="../../Scopes/Synopsis/Lexer.html#restore_lconst.char_S_r" title="member function Synopsis::Lexer::restore(const char*)">restore</a>(<span class="keyword">const</span> <span class="keyword">char</span> *);</span>
<a id="line45"></a><span class="lineno"> 45</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">  <a href="../../Scopes/Synopsis/Lexer.html#Comments" title="typedef Synopsis::Lexer::Comments">Comments</a> <a href="../../Scopes/Synopsis/Lexer.html#get_comments_l_r" title="member function Synopsis::Lexer::get_comments()">get_comments</a>();</span>
<a id="line47"></a><span class="lineno"> 47</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">  <span class="comment">//. Return the origin of the given pointer</span></span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line"><span class="comment">  //. (filename and line number)</span></span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">  <span class="keyword">unsigned long</span> <a href="" title="member function Synopsis::Lexer::origin(const char*,std::string&amp;)const">origin</a>(<span class="keyword">const</span> <span class="keyword">char</span> *, <a href="" title="typedef std::string">std::string</a> &amp;) const;</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line"><span class="keyword">private</span>:</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">  <span class="comment">//. a Queue is used to read in tokens from a stream</span></span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line"><span class="comment">  //. without consuming them</span></span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">  <span class="keyword">class</span> <a href="../../Scopes/Synopsis/Lexer/Queue.html" title="class Synopsis::Lexer::Queue">Queue</a></span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">  {</span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line">  <span class="keyword">public</span>:</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">    <span class="keyword">typedef</span> std::<a href="" title="class std::deque">deque</a>&lt;<a href="../../Scopes/Synopsis/Token.html" title="struct Synopsis::Token">Token</a>&gt; <a href="../../Scopes/Synopsis/Lexer/Queue.html#Container" title="typedef Synopsis::Lexer::Queue::Container">Container</a>;</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line">    <span class="keyword">typedef</span> Container::size_type <a href="../../Scopes/Synopsis/Lexer/Queue.html#size_type" title="typedef Synopsis::Lexer::Queue::size_type">size_type</a>;</span>
<a id="line59"></a><span class="lineno"> 59</span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line">    <span class="keyword">bool</span> <a href="../../Scopes/Synopsis/Lexer/Queue.html#empty_l_rconst" title="member function Synopsis::Lexer::Queue::empty()const">empty</a>() const { <span class="keyword">return</span> <a href="../../Scopes/Synopsis/Lexer/Queue.html#my_container" title="data member Synopsis::Lexer::Queue::my_container">my_container</a>.<a href="" title="member function std::deque::empty()const">empty</a>();}</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">    <a href="../../Scopes/Synopsis/Lexer/Queue.html#size_type" title="typedef Synopsis::Lexer::Queue::size_type">size_type</a> <a href="../../Scopes/Synopsis/Lexer/Queue.html#size_l_rconst" title="member function Synopsis::Lexer::Queue::size()const">size</a>() const { <span class="keyword">return</span> <a href="../../Scopes/Synopsis/Lexer/Queue.html#my_container" title="data member Synopsis::Lexer::Queue::my_container">my_container</a>.<a href="" title="member function std::deque::size()const">size</a>();}</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">    <span class="keyword">const</span> <a href="../../Scopes/Synopsis/Token.html" title="struct Synopsis::Token">Token</a> &amp;<a href="../../Scopes/Synopsis/Lexer/Queue.html#front_l_rconst" title="member function Synopsis::Lexer::Queue::front()const">front</a>() const { <span class="keyword">return</span> <a href="../../Scopes/Synopsis/Lexer/Queue.html#my_container" title="data member Synopsis::Lexer::Queue::my_container">my_container</a>.<a href="" title="member function std::deque::front()">front</a>();}</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">    <span class="keyword">const</span> <a href="../../Scopes/Synopsis/Token.html" title="struct Synopsis::Token">Token</a> &amp;<a href="../../Scopes/Synopsis/Lexer/Queue.html#back_l_rconst" title="member function Synopsis::Lexer::Queue::back()const">back</a>() const { <span class="keyword">return</span> <a href="../../Scopes/Synopsis/Lexer/Queue.html#my_container" title="data member Synopsis::Lexer::Queue::my_container">my_container</a>.<a href="" title="member function std::deque::back()">back</a>();}</span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">    <span class="keyword">const</span> <a href="../../Scopes/Synopsis/Token.html" title="struct Synopsis::Token">Token</a> &amp;<a href="../../Scopes/Synopsis/Lexer/Queue.html#at_lsize_type_rconst" title="member function Synopsis::Lexer::Queue::at(size_type)const">at</a>(<a href="../../Scopes/Synopsis/Lexer/Queue.html#size_type" title="typedef Synopsis::Lexer::Queue::size_type">size_type</a> i) const { <span class="keyword">return</span> <a href="../../Scopes/Synopsis/Lexer/Queue.html#my_container" title="data member Synopsis::Lexer::Queue::my_container">my_container</a>.<a href="" title="member function std::deque::at(size_type)">at</a>(<a href="" title="parameter i">i</a>);}</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">    <span class="keyword">void</span> <a href="../../Scopes/Synopsis/Lexer/Queue.html#push_lconst.Token_A_r" title="member function Synopsis::Lexer::Queue::push(const Token&amp;)">push</a>(<span class="keyword">const</span> <a href="../../Scopes/Synopsis/Token.html" title="struct Synopsis::Token">Token</a> &amp;t) { <a href="../../Scopes/Synopsis/Lexer/Queue.html#my_container" title="data member Synopsis::Lexer::Queue::my_container">my_container</a>.<a href="" title="member function std::deque::push_back(const value_type&amp;)">push_back</a>(<a href="" title="parameter t">t</a>);}</span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">    <span class="keyword">void</span> <a href="../../Scopes/Synopsis/Lexer/Queue.html#pop_l_r" title="member function Synopsis::Lexer::Queue::pop()">pop</a>() { <a href="../../Scopes/Synopsis/Lexer/Queue.html#my_container" title="data member Synopsis::Lexer::Queue::my_container">my_container</a>.<a href="" title="member function std::deque::pop_front()">pop_front</a>();}</span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">    <span class="keyword">void</span> <a href="../../Scopes/Synopsis/Lexer/Queue.html#clear_l_r" title="member function Synopsis::Lexer::Queue::clear()">clear</a>() { <a href="../../Scopes/Synopsis/Lexer/Queue.html#my_container" title="data member Synopsis::Lexer::Queue::my_container">my_container</a>.<a href="" title="member function std::deque::clear()">clear</a>();}</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">  <span class="keyword">private</span>:</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">    <a href="../../Scopes/Synopsis/Lexer/Queue.html#Container" title="typedef Synopsis::Lexer::Queue::Container">Container</a> <a href="../../Scopes/Synopsis/Lexer/Queue.html#my_container" title="data member Synopsis::Lexer::Queue::my_container">my_container</a>;</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">  };</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">  <span class="keyword">typedef</span> std::<a href="" title="class std::map">map</a>&lt;<a href="" title="typedef std::string">std::string</a>, Token::Type&gt; <a href="../../Scopes/Synopsis/Lexer.html#Dictionary" title="typedef Synopsis::Lexer::Dictionary">Dictionary</a>;</span>
<a id="line72"></a><span class="lineno"> 72</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">  <span class="keyword">void</span> <a href="../../Scopes/Synopsis/Lexer.html#rewind_lconst.char_S_r" title="member function Synopsis::Lexer::rewind(const char*)">rewind</a>(<span class="keyword">const</span> <span class="keyword">char</span> *);</span>
<a id="line74"></a><span class="lineno"> 74</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">  <a href="../../Scopes/Synopsis/Token.html#Type" title="typedef Synopsis::Token::Type">Token::Type</a> <a href="../../Scopes/Synopsis/Lexer.html#read_token_lconst.char_S_A_csize_t_A_r" title="member function Synopsis::Lexer::read_token(const char*&amp;,size_t&amp;)">read_token</a>(<span class="keyword">const</span> <span class="keyword">char</span> *&amp;, <a href="" title="typedef size_t">size_t</a> &amp;);</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">  <span class="comment">//. try to fill the token cache to contain</span></span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line"><span class="comment">  //. at least o tokens. Returns false if</span></span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line"><span class="comment">  //. there are not enough tokens.</span></span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line">  <span class="keyword">bool</span> <a href="../../Scopes/Synopsis/Lexer.html#fill_lsize_t_r" title="member function Synopsis::Lexer::fill(size_t)">fill</a>(<a href="" title="typedef size_t">size_t</a> o);</span>
<a id="line80"></a><span class="lineno"> 80</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">  <span class="comment">//. skip till end of paren</span></span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">  <span class="keyword">void</span> <a href="../../Scopes/Synopsis/Lexer.html#skip_paren_l_r" title="member function Synopsis::Lexer::skip_paren()">skip_paren</a>();</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">  <span class="comment">//. skip till end of line</span></span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">  <span class="keyword">void</span> <a href="../../Scopes/Synopsis/Lexer.html#skip_line_l_r" title="member function Synopsis::Lexer::skip_line()">skip_line</a>();</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">  <span class="comment">//. skip __attribute__(...), ___asm__(...), ...</span></span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">  <span class="keyword">void</span> <a href="../../Scopes/Synopsis/Lexer.html#skip_attribute_l_r" title="member function Synopsis::Lexer::skip_attribute()">skip_attribute</a>();</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">  <span class="comment">//. skip __extension__(...).</span></span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">  <a href="../../Scopes/Synopsis/Token.html#Type" title="typedef Synopsis::Token::Type">Token::Type</a> <a href="../../Scopes/Synopsis/Lexer.html#skip_extension_lconst.char_S_A_csize_t_A_r" title="member function Synopsis::Lexer::skip_extension(const char*&amp;,size_t&amp;)">skip_extension</a>(<span class="keyword">const</span> <span class="keyword">char</span> *&amp;, <a href="" title="typedef size_t">size_t</a> &amp;);</span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">  <span class="comment">//. skip __asm ...</span></span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">  <span class="keyword">void</span> <a href="../../Scopes/Synopsis/Lexer.html#skip_asm_l_r" title="member function Synopsis::Lexer::skip_asm()">skip_asm</a>();</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">  <span class="comment">//. skip __declspec(...).</span></span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">  <span class="keyword">void</span> <a href="../../Scopes/Synopsis/Lexer.html#skip_declspec_l_r" title="member function Synopsis::Lexer::skip_declspec()">skip_declspec</a>();</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">  <span class="comment">//. skip __pragma(...);.</span></span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">  <span class="keyword">void</span> <a href="../../Scopes/Synopsis/Lexer.html#skip_pragma_l_r" title="member function Synopsis::Lexer::skip_pragma()">skip_pragma</a>();</span>
<a id="line95"></a><span class="lineno"> 95</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">  <span class="keyword">char</span> <a href="../../Scopes/Synopsis/Lexer.html#get_next_non_white_char_l_r" title="member function Synopsis::Lexer::get_next_non_white_char()">get_next_non_white_char</a>();</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">  <a href="../../Scopes/Synopsis/Token.html#Type" title="typedef Synopsis::Token::Type">Token::Type</a> <a href="../../Scopes/Synopsis/Lexer.html#read_line_l_r" title="member function Synopsis::Lexer::read_line()">read_line</a>();</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">  <span class="keyword">bool</span> <a href="../../Scopes/Synopsis/Lexer.html#read_char_const_lunsigned.long_r" title="member function Synopsis::Lexer::read_char_const(unsigned long)">read_char_const</a>(<span class="keyword">unsigned long</span> top);</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">  <span class="keyword">bool</span> <a href="../../Scopes/Synopsis/Lexer.html#read_str_const_lunsigned.long_r" title="member function Synopsis::Lexer::read_str_const(unsigned long)">read_str_const</a>(<span class="keyword">unsigned long</span> top);</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">  <a href="../../Scopes/Synopsis/Token.html#Type" title="typedef Synopsis::Token::Type">Token::Type</a> <a href="../../Scopes/Synopsis/Lexer.html#read_number_lchar_cunsigned.long_r" title="member function Synopsis::Lexer::read_number(char,unsigned long)">read_number</a>(<span class="keyword">char</span> c, <span class="keyword">unsigned long</span> top);</span>
<a id="line101"></a><span class="lineno">101</span><span class="line">  <a href="../../Scopes/Synopsis/Token.html#Type" title="typedef Synopsis::Token::Type">Token::Type</a> <a href="../../Scopes/Synopsis/Lexer.html#read_float_lunsigned.long_r" title="member function Synopsis::Lexer::read_float(unsigned long)">read_float</a>(<span class="keyword">unsigned long</span> top);</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">  <a href="../../Scopes/Synopsis/Token.html#Type" title="typedef Synopsis::Token::Type">Token::Type</a> <a href="../../Scopes/Synopsis/Lexer.html#read_identifier_lunsigned.long_r" title="member function Synopsis::Lexer::read_identifier(unsigned long)">read_identifier</a>(<span class="keyword">unsigned long</span> top);</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">  <a href="../../Scopes/Synopsis/Token.html#Type" title="typedef Synopsis::Token::Type">Token::Type</a> <a href="../../Scopes/Synopsis/Lexer.html#screen_lconst.char_S_csize_t_r" title="member function Synopsis::Lexer::screen(const char*,size_t)">screen</a>(<span class="keyword">const</span> <span class="keyword">char</span> *identifier, <a href="" title="typedef size_t">size_t</a> len);</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">  <a href="../../Scopes/Synopsis/Token.html#Type" title="typedef Synopsis::Token::Type">Token::Type</a> <a href="../../Scopes/Synopsis/Lexer.html#read_separator_lchar_cunsigned.long_r" title="member function Synopsis::Lexer::read_separator(char,unsigned long)">read_separator</a>(<span class="keyword">char</span> c, <span class="keyword">unsigned long</span> top);</span>
<a id="line105"></a><span class="lineno">105</span><span class="line">  <a href="../../Scopes/Synopsis/Token.html#Type" title="typedef Synopsis::Token::Type">Token::Type</a> <a href="../../Scopes/Synopsis/Lexer.html#single_char_op_lunsigned.char_r" title="member function Synopsis::Lexer::single_char_op(unsigned char)">single_char_op</a>(<span class="keyword">unsigned char</span> c);</span>
<a id="line106"></a><span class="lineno">106</span><span class="line">  <a href="../../Scopes/Synopsis/Token.html#Type" title="typedef Synopsis::Token::Type">Token::Type</a> <a href="../../Scopes/Synopsis/Lexer.html#read_comment_lchar_cunsigned.long_r" title="member function Synopsis::Lexer::read_comment(char,unsigned long)">read_comment</a>(<span class="keyword">char</span> c, <span class="keyword">unsigned long</span> top);</span>
<a id="line107"></a><span class="lineno">107</span>
<a id="line108"></a><span class="lineno">108</span><span class="line">  <a href="../../Scopes/Synopsis/Buffer.html" title="class Synopsis::Buffer">Buffer</a>    *<a href="../../Scopes/Synopsis/Lexer.html#my_buffer" title="data member Synopsis::Lexer::my_buffer">my_buffer</a>;</span>
<a id="line109"></a><span class="lineno">109</span><span class="line">  <a href="../../Scopes/Synopsis/Lexer/Queue.html" title="class Synopsis::Lexer::Queue">Queue</a>      <a href="../../Scopes/Synopsis/Lexer.html#my_tokens" title="data member Synopsis::Lexer::my_tokens">my_tokens</a>;</span>
<a id="line110"></a><span class="lineno">110</span><span class="line">  <a href="../../Scopes/Synopsis/Lexer.html#Dictionary" title="typedef Synopsis::Lexer::Dictionary">Dictionary</a> <a href="../../Scopes/Synopsis/Lexer.html#my_keywords" title="data member Synopsis::Lexer::my_keywords">my_keywords</a>;</span>
<a id="line111"></a><span class="lineno">111</span><span class="line">  <a href="../../Scopes/Synopsis/Token.html" title="struct Synopsis::Token">Token</a>      <a href="../../Scopes/Synopsis/Lexer.html#my_token" title="data member Synopsis::Lexer::my_token">my_token</a>;</span>
<a id="line112"></a><span class="lineno">112</span><span class="line">  <a href="../../Scopes/Synopsis/Lexer.html#Comments" title="typedef Synopsis::Lexer::Comments">Comments</a>   <a href="../../Scopes/Synopsis/Lexer.html#my_comments" title="data member Synopsis::Lexer::my_comments">my_comments</a>;</span>
<a id="line113"></a><span class="lineno">113</span><span class="line">};</span>
<a id="line114"></a><span class="lineno">114</span>
<a id="line115"></a><span class="lineno">115</span><span class="line">inline <span class="keyword">bool</span> <a href="../../Scopes/Synopsis.html#is_blank_lchar_r" title="function Synopsis::is_blank(char)">is_blank</a>(<span class="keyword">char</span> c)</span>
<a id="line116"></a><span class="lineno">116</span><span class="line">{</span>
<a id="line117"></a><span class="lineno">117</span><span class="line">  <span class="keyword">return</span> <a href="" title="parameter c">c</a> == <span class="string">' '</span> || <a href="" title="parameter c">c</a> == <span class="string">'\t'</span> || <a href="" title="parameter c">c</a> == <span class="string">'\f'</span> || <a href="" title="parameter c">c</a> == <span class="string">'\r'</span>;</span>
<a id="line118"></a><span class="lineno">118</span><span class="line">}</span>
<a id="line119"></a><span class="lineno">119</span>
<a id="line120"></a><span class="lineno">120</span><span class="line">inline <span class="keyword">bool</span> <a href="../../Scopes/Synopsis.html#is_letter_lchar_r" title="function Synopsis::is_letter(char)">is_letter</a>(<span class="keyword">char</span> c)</span>
<a id="line121"></a><span class="lineno">121</span><span class="line">{</span>
<a id="line122"></a><span class="lineno">122</span><span class="line">  <span class="keyword">return</span> (<span class="string">'A'</span> &lt;= <a href="" title="parameter c">c</a> &amp;&amp; <a href="" title="parameter c">c</a> &lt;= <span class="string">'Z'</span>) || (<span class="string">'a'</span> &lt;= <a href="" title="parameter c">c</a> &amp;&amp; <a href="" title="parameter c">c</a> &lt;= <span class="string">'z'</span>) || (<a href="" title="parameter c">c</a> == <span class="string">'_'</span> || <a href="" title="parameter c">c</a> == <span class="string">'$'</span>);</span>
<a id="line123"></a><span class="lineno">123</span><span class="line">}</span>
<a id="line124"></a><span class="lineno">124</span>
<a id="line125"></a><span class="lineno">125</span><span class="line">inline <span class="keyword">bool</span> <a href="../../Scopes/Synopsis.html#is_digit_lchar_r" title="function Synopsis::is_digit(char)">is_digit</a>(<span class="keyword">char</span> c){ <span class="keyword">return</span> <span class="string">'0'</span> &lt;= <a href="" title="parameter c">c</a> &amp;&amp; <a href="" title="parameter c">c</a> &lt;= <span class="string">'9'</span>;}</span>
<a id="line126"></a><span class="lineno">126</span>
<a id="line127"></a><span class="lineno">127</span><span class="line">inline <span class="keyword">bool</span> <a href="../../Scopes/Synopsis.html#is_xletter_lchar_r" title="function Synopsis::is_xletter(char)">is_xletter</a>(<span class="keyword">char</span> c){ <span class="keyword">return</span> <a href="" title="parameter c">c</a> == <span class="string">'X'</span> || <a href="" title="parameter c">c</a> == <span class="string">'x'</span>;}</span>
<a id="line128"></a><span class="lineno">128</span>
<a id="line129"></a><span class="lineno">129</span><span class="line">inline <span class="keyword">bool</span> <a href="../../Scopes/Synopsis.html#is_eletter_lchar_r" title="function Synopsis::is_eletter(char)">is_eletter</a>(<span class="keyword">char</span> c){ <span class="keyword">return</span> <a href="" title="parameter c">c</a> == <span class="string">'E'</span> || <a href="" title="parameter c">c</a> == <span class="string">'e'</span>;}</span>
<a id="line130"></a><span class="lineno">130</span>
<a id="line131"></a><span class="lineno">131</span><span class="line">inline <span class="keyword">bool</span> <a href="../../Scopes/Synopsis.html#is_hexdigit_lchar_r" title="function Synopsis::is_hexdigit(char)">is_hexdigit</a>(<span class="keyword">char</span> c)</span>
<a id="line132"></a><span class="lineno">132</span><span class="line">{</span>
<a id="line133"></a><span class="lineno">133</span><span class="line">  <span class="keyword">return</span> <a href="../../Scopes/Synopsis.html#is_digit_lchar_r" title="function Synopsis::is_digit(char)">is_digit</a>(<a href="" title="parameter c">c</a>) || (<span class="string">'A'</span> &lt;= <a href="" title="parameter c">c</a> &amp;&amp; <a href="" title="parameter c">c</a> &lt;= <span class="string">'F'</span>) || (<span class="string">'a'</span> &lt;= <a href="" title="parameter c">c</a> &amp;&amp; <a href="" title="parameter c">c</a> &lt;= <span class="string">'f'</span>);</span>
<a id="line134"></a><span class="lineno">134</span><span class="line">}</span>
<a id="line135"></a><span class="lineno">135</span>
<a id="line136"></a><span class="lineno">136</span><span class="line">inline <span class="keyword">bool</span> <a href="../../Scopes/Synopsis.html#is_int_suffix_lchar_r" title="function Synopsis::is_int_suffix(char)">is_int_suffix</a>(<span class="keyword">char</span> c)</span>
<a id="line137"></a><span class="lineno">137</span><span class="line">{</span>
<a id="line138"></a><span class="lineno">138</span><span class="line">  <span class="keyword">return</span> <a href="" title="parameter c">c</a> == <span class="string">'U'</span> || <a href="" title="parameter c">c</a> == <span class="string">'u'</span> || <a href="" title="parameter c">c</a> == <span class="string">'L'</span> || <a href="" title="parameter c">c</a> == <span class="string">'l'</span>;</span>
<a id="line139"></a><span class="lineno">139</span><span class="line">}</span>
<a id="line140"></a><span class="lineno">140</span>
<a id="line141"></a><span class="lineno">141</span><span class="line">inline <span class="keyword">bool</span> <a href="../../Scopes/Synopsis.html#is_float_suffix_lchar_r" title="function Synopsis::is_float_suffix(char)">is_float_suffix</a>(<span class="keyword">char</span> c)</span>
<a id="line142"></a><span class="lineno">142</span><span class="line">{</span>
<a id="line143"></a><span class="lineno">143</span><span class="line">  <span class="keyword">return</span> <a href="" title="parameter c">c</a> == <span class="string">'F'</span> || <a href="" title="parameter c">c</a> == <span class="string">'f'</span> || <a href="" title="parameter c">c</a> == <span class="string">'L'</span> || <a href="" title="parameter c">c</a> == <span class="string">'l'</span>;</span>
<a id="line144"></a><span class="lineno">144</span><span class="line">}</span>
<a id="line145"></a><span class="lineno">145</span>
<a id="line146"></a><span class="lineno">146</span><span class="line">}</span>
<a id="line147"></a><span class="lineno">147</span>
<a id="line148"></a><span class="lineno">148</span><span class="line">#endif</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:28:04 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
